clc; clear; close all;
addpath img\original_scale;
addpath utilties;
addpath model;
addpath model\Matlab ;

%% parameter settings
params.device_mode = 'gpu';          %   'gpu' or 'cpu'
params.dynamic_range = 11 ;
params.scale = 4;
params.max_value = 2^params.dynamic_range - 1 ;
params.sensor = 'WV2' ;
params.model = 'model\MatCaffe\baoming_deploy.prototxt';
params.weights = 'model\MatCaffe\_iter_3000.caffemodel';
params.RGB_index = [5 3 2];

%% loading data
load 'WV2_Original_Sample_1.mat';
% load 'WV2_Original_Sample_2.mat';
% load 'WV3_Original_Sample.mat';

%% preprocess
ms = double(ms) ;
pan = double(pan) ;
LRMS = interp23tap(ms, params.scale) ;
LRMS = LRMS / params.max_value ;
pan = pan / params.max_value ;

%% fusion process
proposed = proposed(LRMS, pan, params);

%%  visualization
proposed_visualize = visualize(proposed , [0.01 , 0.97]) ;
LRMS_visualize = visualize(LRMS , [0.01 , 0.97]) ;
ms_visualize = visualize(ms , [0.01 , 0.97]) ;
pan_visualize = visualize(pan , [0.01 , 0.97]) ;

figure();
subplot(2,2,1); imshow(pan_visualize) ; title('Original PAN') ;
subplot(2,2,2); imshow(ms_visualize(:,:,params.RGB_index)) ; title('Original MS') ;
subplot(2,2,3); imshow(LRMS_visualize(:,:,params.RGB_index)) ; title('Upsampled MS') ;
subplot(2,2,4); imshow(proposed_visualize(:,:,params.RGB_index)) ; title('Proposed Result') ;